/*
	pid_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	12-Sep-99	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "pidn.hh" 	// pidFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *pid_cmd = NULL;
static RCS_STAT_CHANNEL *pid_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// pid
	pid_cmd = new RCS_CMD_CHANNEL(pidFormat, "pid_cmd", "pid_modulesvr", "pid_module.nml");
	if(NULL == pid_cmd)
		return -1;
	if(!pid_cmd->valid())
		return -1;

	pid_stat = new RCS_STAT_CHANNEL(pidFormat, "pid_sts", "pid_modulesvr", "pid_module.nml");
	if(NULL == pid_stat)
		return -1;
	if(!pid_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "pid_modulesvr", "pid_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// pid
	if(NULL != pid_cmd)
	{
		delete pid_cmd;
		pid_cmd = NULL;
	}

	if(NULL != pid_stat)
	{
		delete pid_stat;
		pid_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int pid_modulesvr_run();

int pid_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

